Package: io.vertx.groovy.core.parsetools

## [Groovy] Class RecordParser

- io.vertx.groovy.core.parsetools.RecordParser

- All Implemented Interfaces and Traits:
    io.vertx.core.Handler

      @groovy.transform.CompileStatic
      class RecordParser
      extends java.lang.Object

  A helper class which allows you to easily parse protocols which are delimited by a sequence of bytes, or fixed size records.

  Instances of this class take as input Buffer instances containing raw bytes, and output records.

  For example, if I had a simple ASCII text protocol delimited by '\n' and the input was the following:

       buffer1:HELLO\nHOW ARE Y
       buffer2:OU?\nI AM
       buffer3: DOING OK
       buffer4:\n

  Then the output would be:

       buffer1:HELLO
       buffer2:HOW ARE YOU?
       buffer3:I AM DOING OK

  Instances of this class can be changed between delimited mode and fixed size record mode on the fly as individual records are read, this allows you to parse protocols where, for example, the first 5 records might all be fixed size (of potentially different sizes), followed by some delimited records, followed by more fixed size records.

  Instances of this class can't currently be used for protocols where the text is encoded with something other than a 1-1 byte-char mapping.

  Please see the documentation for more information.

- - ### Constructor Summary

    Constructors
    Constructor and description
    `RecordParser (java.lang.Object delegate)`

  - ### Methods Summary

    Methods
    Type | Name and description
    --- | ---
    `void` | `delimitedMode(java.lang.String delim)` Flip the parser into delimited mode, and where the delimiter can be represented by the String `delim` encoded in latin-1 .
    `void` | `delimitedMode(Buffer delim)` Flip the parser into delimited mode, and where the delimiter can be represented by the delimiter `delim`.
    `void` | `fixedSizeMode(int size)` Flip the parser into fixed size mode, where the record size is specified by `size` in bytes.
    `java.lang.Object` | `getDelegate()`
    `void` | `handle(Buffer buffer)` This method is called to provide the parser with data.
    `static RecordParser` | `newDelimited(java.lang.String delim, io.vertx.core.Handler<Buffer> output)` Create a new `RecordParser` instance, initially in delimited mode, and where the delimiter can be represented by the String `` delim endcoded in latin-1 .
    `static RecordParser` | `newDelimited(Buffer delim, io.vertx.core.Handler<Buffer> output)` Create a new `RecordParser` instance, initially in delimited mode, and where the delimiter can be represented by the `Buffer` delim.
    `static RecordParser` | `newFixed(int size, io.vertx.core.Handler<Buffer> output)` Create a new `RecordParser` instance, initially in fixed size mode, and where the record size is specified by the `size` parameter.
    `void` | `setOutput(io.vertx.core.Handler<Buffer> output)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class java.lang.Object` | `java.lang.Object#wait(long, int), java.lang.Object#wait(long), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()`

- - ### Constructor Detail

    - #### RecordParser(java.lang.Object delegate)

  - ### Method Detail

    - #### void delimitedMode(java.lang.String delim)

      Flip the parser into delimited mode, and where the delimiter can be represented by the String `delim` encoded in latin-1 . Don't use this if your String contains other than latin-1 characters.

      This method can be called multiple times with different values of delim while data is being parsed.

      Parameters:
        `delim` - the new delimeter

    - #### void delimitedMode(Buffer delim)

      Flip the parser into delimited mode, and where the delimiter can be represented by the delimiter `delim`.

      This method can be called multiple times with different values of delim while data is being parsed.

      Parameters:
        `delim` - the new delimiter

    - #### void fixedSizeMode(int size)

      Flip the parser into fixed size mode, where the record size is specified by `size` in bytes.

      This method can be called multiple times with different values of size while data is being parsed.

      Parameters:
        `size` - the new record size

    - #### java.lang.Object getDelegate()

    - #### void handle(Buffer buffer)

      This method is called to provide the parser with data.

      Parameters:
        `buffer` - a chunk of data

    - #### static RecordParser newDelimited(java.lang.String delim, io.vertx.core.Handler<Buffer> output)

      Create a new `RecordParser` instance, initially in delimited mode, and where the delimiter can be represented by the String `` delim endcoded in latin-1 . Don't use this if your String contains other than latin-1 characters.

      `output` Will receive whole records which have been parsed.

      Returns:
      Parameters:
        `delim` - the initial delimiter string
        `output` - handler that will receive the output

    - #### static RecordParser newDelimited(Buffer delim, io.vertx.core.Handler<Buffer> output)

      Create a new `RecordParser` instance, initially in delimited mode, and where the delimiter can be represented by the `Buffer` delim.

      `output` Will receive whole records which have been parsed.

      Returns:
      Parameters:
        `delim` - the initial delimiter buffer
        `output` - handler that will receive the output

    - #### static RecordParser newFixed(int size, io.vertx.core.Handler<Buffer> output)

      Create a new `RecordParser` instance, initially in fixed size mode, and where the record size is specified by the `size` parameter.

      `output` Will receive whole records which have been parsed.

      Returns:
      Parameters:
        `size` - the initial record size
        `output` - handler that will receive the output

    - #### void setOutput(io.vertx.core.Handler<Buffer> output)